(* 
   petit programme de calcul du crible d'Eratosthene

*)

let size = int_of_string Sys.argv.(1) ;;
let nb_th = int_of_string Sys.argv.(2) ;; 

let last_pn = ref 1;;
let sieve = Array.create size true;;

let rec find n = 
  if n = size then -1
  else 
    if sieve.(n) then n 
    else find (n+1)
;;

let mark n = 
  last_pn := n;
  for i = n+1 to size-1 do 
    if i mod n == 0 then sieve.(i) <- false
  done
;;


let rec compute () =
  if !last_pn < size then  
    let next = find (!last_pn + 1) in 
    if next > 1 then 
     ( mark next;
      compute())
    else ()
  else ()
;;

let check () = 
  let res = ref 0 in 
  for i=2 to size-1 do 
    if sieve.(i) then incr res
  done;
  !res
;;

let dummy () =
  (* for i = 0 to 10 do
    let _ = Array.make 100000 42
    in ()
  done
  *)
()

let rec create n f = 
  dummy ();
  if n = 0 then [] 
  else let r = Thread.create f () in r:: create (n-1) f
;;

let waitfor lv = 
  List.iter Thread.join lv
;;

let main() = 
  let ls = create nb_th compute in  
    waitfor ls;
  let nb = check () in 
    print_int nb; 
    print_newline()
;;

main();;


