let array_init l f =
  if l = 0 then [||] else   let res = Array.create l (f 0) in   for i = 1 to pred l do     Array.set res i (f i)
  done;
   res

let get g x y =
  try g.(x).(y)
  with _ -> 0
 
let neighbourhood g x y =
  (get g (x-1) (y-1)) +
  (get g (x-1) (y  )) +
  (get g (x-1) (y+1)) +
  (get g (x  ) (y-1)) +
  (get g (x  ) (y+1)) +
  (get g (x+1) (y-1)) +
  (get g (x+1) (y  )) +
  (get g (x+1) (y+1)) 
 
let next_cell g x y =
  let n = neighbourhood g x y in
  match g.(x).(y), n with
    | 1, 0 | 1, 1                      -> 0  (* lonely *)
    | 1, 4 | 1, 5 | 1, 6 | 1, 7 | 1, 8 -> 0  (* overcrowded *)
    | 1, 2 | 1, 3                      -> 1  (* lives *)
    | 0, 3                             -> 1  (* get birth *)
    | _ (* 0, (0|1|2|4|5|6|7|8) *)     -> 0  (* barren *)
 
let copy g = Array.map Array.copy g
 
let next g =
  let width = Array.length g
  and height = Array.length g.(0)
  and new_g = copy g in
  let threads = array_init (pred width) (Thread.create (
  fun x -> 
    for y = 0 to pred height do
     new_g.(x).(y) <- (next_cell g x y)
    done
					 ))
  in Array.iter Thread.join threads;
  (new_g)
 
let print g =
  print_endline "plop";
  let width = Array.length g in
    Printf.printf "<%d> <%d>" width (Obj.magic g.(0));
    print_endline "plop";
  let height = Array.length g.(0) in
  print_endline "plop";
  for x = 0 to pred width do
    for y = 0 to pred height do
      if g.(x).(y) = 0
      then print_char '.'
      else print_char 'o'
    done;
    print_newline()
  done
  
let g =
  array_init 1000 (fun _ -> (array_init 100 (fun _ -> Random.int(2))))
  
let _ = 
  let tmp = ref g in
    print !tmp;
    for i = 0 to 100 do
    tmp := next !tmp;
    print !tmp
    done
