open Unix

type t = {
  thread : Thread.t;
  mutex : Mutex.t;
}
let thread_create f a =
  let m = Mutex.create () in
  let () = Mutex.lock m in
    {
      thread = Thread.create
	(fun () -> try f a ; Mutex.unlock m with e -> Mutex.unlock m ; raise e)
	();
      mutex = m
    }
let thread_join t =
  Mutex.lock t.mutex;
  Mutex.unlock t.mutex

let thread_create = Thread.create
let thread_join = Thread.join


let mkmatrix rows cols =
    let count = ref 1.0
    and last_col = cols - 1
    and m = Array.make_matrix rows cols 42. in
      (*
  for i = 0 to rows - 1 do
    let mi = m.(i) in
      for j = 0 to last_col do
      mi.(j) <- !count;
      count:= !count *. 1.77 
    done;
  done;
      *)
  m

let t1 = ref (Unix.times ())
let t2 = ref (Unix.times ())

let m = ref (Mutex.create () )

let size = ref 0

let process_line n m1 m2 m3=
    for x = 0 to !size-1 do
      for y = 0 to !size-1 do
       m3.(n).(x) <- m3.(n).(x) +. m1.(n).(y) *. m2.(y).(x)
      done;
    done
      
      
(* compteur de taches *)
(*let get_n =
  let c = ref 0 in
    fun () -> 
      begin
	Mutex.lock !m;
	let ret = !c in
	  c := ret + 1;
	  Mutex.unlock !m;
	  ret
      end
*)
	
	
let rec worker m1 m2 m3 max=
(*  let n = get_n () in*)
  (*if n >= !size then ()
    else*)
  let th = (Thread.id (Thread.self())) in
  let n_min = (th-1) *(Array.length m1/max)
  and n_max = (th) *(Array.length m1/max) in 
    begin
      for n=n_min to n_max-1 do
	(process_line n m1 m2 m3);
      done
	(*      if ((Thread.id (Thread.self()) )=(max+1)) then
		for i=n_max to ((Array.length m1)-1)do
		(process_line n m1 m2 m3);
		done*)
	(*  (worker m1 m2 m3)*)
    end
      
	
	
let _ =
  size := int_of_string Sys.argv.(1) ;
  let m1 = mkmatrix !size !size
  and m2 = mkmatrix !size !size
  and m3 = Array.make_matrix !size !size 0. in
  (
    t1 := Unix.times ();
    let ta = Unix.gettimeofday () in
      (
	let threads =
	  Array.init
	    (int_of_string Sys.argv.(2))
	    (fun _ -> (Thread.create (worker m1 m2 m3) (int_of_string Sys.argv.(2))) )
	in
	  Array.iter Thread.join threads;
	  t2 := Unix.times ();
	  let tb = Unix.gettimeofday () in
	    Printf.printf "Temp de calcul: utime %f, stime %f, rtime %f\n" (!t2.tms_utime -. !t1.tms_utime) (!t2.tms_stime-. !t1.tms_stime) (tb -. ta);
      );
      try
	(
	  if Sys.argv.(3) = "p" then
	    (
	      for i =0 to !size-1 do
		for j = 0 to !size-1 do
		  Printf.printf "%f " m3.(i).(j) 
		done;
		Printf.printf "\n"  
	      done
	    );
	)
      with e ->()
  )
